<?php







class StaticDatasource extends AbstractDatasource
{
 var $m_firstStep;
 var $m_list = array();
 var $m_params = null;

 function StaticDatasource() {
 $this->m_params = new ParamHelper();
 }
 
 function getTypeName()
 {
 return i18n( "Static Datasource" );
 }
 
 function getType()
 {
 return DATASOURCE_STATIC;
 }

 function setFirstStep( $stepNr )
 {
 $this->m_firstStep = $stepNr;
 }

 function updateStep( &$wizard, $stepNr, &$form )
 {
 $step =& $wizard->getStep( $stepNr );
 $vac =& $step->getComponent( "vals" );
 $wizard->setButtonsVisibility( $vac->buttonsVisible() ); 
 }
 
 function createStep( &$wizard, $stepNr, &$form )
 {
 node_class( "valueaddcomponent" );
 $va = new ValueaddComponent( i18n( "sValue" ), i18n( "sName" ) );
 $list = array();
 foreach ( $this->m_list as $key=>$value )
 {
 $list[$key] = array( "name"=>$value["key"], "value"=>$value["value"] );
 }
 $va->setList( $list, $this->m_params->getParam( "maxid", -1 ) );
 $form->addComponent( "vals", $va );
 $wizard->lastStep();
 }
 
 function done( &$wizard )
 {
 $step =& $wizard->getStep( $this->m_firstStep );
 $v =& $step->getComponent( "vals" );
 $list = $v->getList();
 $this->m_list = array();
 foreach ( $list as $key=>$value )
 {
 $this->m_list[$key] = array( "key"=>$value["name"], "value"=>$value["value"] );
 }
 $this->m_params->setParam( "maxid", $v->getMaxID() );
 }
 
 function load( $list, &$params )
 {
 $this->m_list = $list;
 $this->m_params =& $params;
 }
 
 function &getParams()
 {
 return $this->m_params;
 }
 
 function export()
 {
 return $this->m_list;
 }

 function exportValues()
 {
 return $this->m_list;
 }
 
 
 function exportIds()
 {
 return array_keys( $this->m_list );
 }
 
 function getEventDependencies()
 {
 



 }
 
 function translate( $ids, $template )
 {
 $prefix = "ds";
 $prefixLength = strlen( $prefix );
 $offset = 0;
 $parts = array();
 
 if ( strlen( trim( $template ) ) == 0 )
 $template = "<$prefix value>";
 
 while ( !is_false( $pos1 = strpos( $template, "<$prefix ", $offset ) ) )
 {
 $start = $pos1 + 2 + $prefixLength;
 $pos2 = strpos( $template, ">", $start );
 $length = $pos1 - $offset;
 $parts[] = array( "str"=>substr( $template, $offset, $length ), "type"=>1 );
 $length = $pos2-$start;
 $parts[] = array( "str"=>trim(substr( $template, $start, $length )), "type"=>2 );
 
 $offset = $pos2+1; 
 }
 $parts[] = array( "str"=>substr($template, $offset), "type"=>1 );
 $ret = "";
 $i = 1;
 $props = array();
 foreach ( $ids as $id )
 {
 if ( $i == 1 ) {
 $props["value"] = $this->m_list[$id]["value"];
 $props["key"] = $this->m_list[$id]["key"];
 }
 $props["$i.value"] = $this->m_list[$id]["value"];
 $props["$i.key"] = $this->m_list[$id]["key"];
 $props["values"][] = $this->m_list[$id]["value"];
 $props["keys"][] = $this->m_list[$id]["key"];
 foreach ( $parts as $part )
 {
 switch ( $part["type"] )
 {
 
 case 1:
 $ret .= $part["str"];
 break;
 
 case 2:
 switch ( $part["str"] )
 {
 case "value":
 $ret .= $this->m_list[$id]["value"];
 break;
 case "nr":
 $ret .= $i; 
 break;
 case "name":
 case "key":
 $ret .= $this->m_list[$id]["key"];
 break;
 }
 break;
 }
 }
 $i++;
 }
 return array( "value"=>$ret, "props"=>$props );
 }
}

?>
